/************************************************************************/
/* Author: 	Hirotaka Miura.						*/
/* Contact: 	Hirotaka.Miura@gmail.com.				*/
/************************************************************************/

/************************************************************************/
/* 04/24/2011: 	Modified.						*/
/* 04/22/2011: 	Previouly modified.					*/
/* 04/22/2011: 	Created.						*/
/************************************************************************/

/************************************************************************/
/* Program: 	adjacency_list().					*/
/* Function: 	Generate edge and weight adjacency lists.		*/
/************************************************************************/
mata:
struct matrix_struct scalar adjacency_list(real matrix E){
  /* Declare variables.							*/
  struct matrix_struct scalar z /* Matrix return structure.		*/
  real matrix L1 /* Adjacency list.					*/
  real matrix L2 /* Weight adjacency list.				*/
  real scalar i /* Row counter.						*/
  real scalar m /* Total number of nodes.				*/
  real scalar k /* Track max columns.					*/
  real scalar j /* Column index.					*/
  /* Begin program.							*/
  /* Define adjacency and weight adjacency lists.			*/
  m=max(E[.,(1,2)]); L1=J(m,m,.); L2=J(m,m,.)
  k=0
  /* Loop through each row of augmented edge list.			*/
  for(i=1;i<=rows(E);i++){
    /* Obtain column index.						*/
    j=nonmissing(L1[E[i,1],.])+1
    /* Record adjacent node number.					*/
    L1[E[i,1],j]=E[i,2]  
    /* Record weight of edge going out to adjacent node.		*/
    L2[E[i,1],j]=E[i,3] 
    /* Update max number of columns.					*/
    if(k<j) k=j
  }
  /* Remove empty columns.						*/
  L1=L1[.,(1..k)]; L2=L2[.,(1..k)]
  /* Return adjacency and weight adjacency lists.			*/
  z.X1=L1; z.X2=L2
  return(z)
}
end

