/************************************************************************/
/* Author: 	Hirotaka Miura.						*/
/* Contact: 	Hirotaka.Miura@gmail.com.				*/
/************************************************************************/

/************************************************************************/
/* 05/01/2011: 	Modified.						*/
/* 04/24/2011: 	Previouly modified.					*/
/* 04/22/2011: 	Created.						*/
/************************************************************************/

/************************************************************************/
/* Program: 	sparse2full().						*/
/* Function: 	Convert sparse matrix to full matrix.			*/
/************************************************************************/
mata:
real matrix sparse2full(real matrix S, |real scalar initial){
  /* Declare variables. 						*/
  real matrix M /* Return full matrix.					*/
  real scalar m /* Matrix dimension.					*/
  real scalar i /* Row counter.						*/  
  /***** Obtain matrix dimensions and define return matrix.		*/
  m=max(S[.,(1,2)])
  /* Set initial values.  By default initial values are set to missing.	*/
  M=J(m,m,initial)
  /* Populate full matrix to be returned.				*/
  for(i=1;i<=rows(S);i++) M[S[i,1],S[i,2]]=S[i,3]
  /* Return full matrix.						*/
  return(M)
}
end
